/**
 * @author JunDing
 * @since Jan31,2013
 * This code is used to get the lambda for motifs, which will be used to 
 * caluclat the signiciance of motif combinations. 
 * 
*/
import java.io.*;
import java.util.*;
class getLambda{
	public static void main(String[] args) throws IOException {
		// read in the motifs 
		BufferedReader f=new BufferedReader (new FileReader(args[1]));
		String Line;
		StringBuffer SB=new StringBuffer();
		String AM;
		String[] AMS;
		int i;
		while((Line=f.readLine())!=null){
			SB.append(Line+"\n");
		}
		f.close();
		AM=SB.toString();
		AMS=AM.split("\\>");
		
		//read in the permuted sequences
		BufferedReader g=new BufferedReader (new FileReader(args[0]));
		StringBuffer SeqBuffer=new StringBuffer();
		String[] SeqArray;
		double cut;
		cut=Double.parseDouble(args[2]);
		double[] bk={0.290763621993511,0.202156441211073,0.205656409776978,0.301423527018438}; // ACGT frequency
		double[] out;
		while((Line=g.readLine())!=null){
			if(Line.contains(">")==false){
				SeqBuffer.append(Line+"\n");
			}
		}
		g.close();
		SeqArray=SeqBuffer.toString().split("\\\n");
		
		getLambda GL=new getLambda();
		//scan
		// output dir
		String outputdir;
		outputdir=args[3];
		double progress=0;
		BufferedWriter h =new BufferedWriter(new FileWriter(args[1]+"_lambda"));
		for(i=1;i<AMS.length;i++){
			out=GL.scan(AMS[i],SeqArray,cut,bk);
			h.write(out[0]+"\t"+out[1]+"\n");
			//System.out.println(out[0]);
			progress=(i+0.0)/AMS.length;
			progress=progress*100;
			System.out.format("\r %2d",(int) progress);
			System.out.print("%");
		}
		System.out.println("\r100%");
		h.close();
	}
	
	
	public double[] scan(String M, String[] SeqArray, double cut, double[] bk){
		//This function is used to get the cutoff for each motif at lamba cutoff= cut
		//M is the input motif, SeqArray is the input sequence array
		String[] Mot;
		int i,j,k;
		int Msize;
		String Seq;
		String Prob;
		String[] tmp;
		double score,min_score=0,max_score=0; // min and max score for motif
		double[] PosArray={0,0,0,0}; 
		double step;
		double loc_tmp;
		double lam;
		int loc;
		int num=0;
		int NN=0;
		int N=100; //split the score into 100 bins
		double[] Reg=new double[101];
		double[] Count=new double[101];
		double[] out=new double[2];
		ArrayList<String[]> MM=new ArrayList<String[]> (); //motif
		Mot=M.split("\\\n");
		for(i=1;i<Mot.length;i++){
			tmp=Mot[i].split(" ");
			PosArray[0]=Math.log(Double.parseDouble(tmp[0])/bk[0]);
			PosArray[1]=Math.log(Double.parseDouble(tmp[1])/bk[1]);
			PosArray[2]=Math.log(Double.parseDouble(tmp[2])/bk[2]);
			PosArray[3]=Math.log(Double.parseDouble(tmp[3])/bk[3]);
			Arrays.sort(PosArray);
			//System.out.println(PosArray[0]+","+PosArray[1]+","+PosArray[2]+","+PosArray[3]);
			min_score+=PosArray[0];
			max_score+=PosArray[PosArray.length-1];
			MM.add(tmp);
		}
		
		//System.out.println(min_score);
		//System.out.println(max_score);
		Msize=MM.size();
		for(i=0;i<=100;i++){
			step=(max_score-min_score)/N;
			Reg[i]=min_score+step*i;
		}
			
		// begin scanning
		for(i=0;i<SeqArray.length;i++){
			Seq=SeqArray[i];
			for(j=0;j<Seq.length();j++){
				if (Seq.charAt(j)!='N'){
					NN+=1;
				}
			}
			for(j=0;j<Seq.length()-Msize+1;j++){
				Prob=Seq.substring(j,j+Msize);
				score=0;
				for(k=0;k<Prob.length();k++){
					tmp=MM.get(k);
					if(Prob.substring(k,k+1).equals("A")){
						score+=Math.log(Double.parseDouble(tmp[0])/bk[0]);
					}else if (Prob.substring(k,k+1).equals("C")){
						score+=Math.log(Double.parseDouble(tmp[1])/bk[1]);
					}else if (Prob.substring(k,k+1).equals("G")){
						score+=Math.log(Double.parseDouble(tmp[2])/bk[2]);
					}else if (Prob.substring(k,k+1).equals("T")){
						score+=Math.log(Double.parseDouble(tmp[3])/bk[3]);
					}else{
						
					}
				}
				loc_tmp=(score-min_score)/(max_score-min_score)*N;
				loc=(int)loc_tmp;
				//System.out.println(loc);
				Count[loc]+=1;
			}
		}
		
		for(i=Count.length-1;i>0;i--){
			num+=Count[i];
			if (num>NN*cut){
				break;
			}
		}
		//System.out.println(num);
		//System.out.println(NN);
		score=Reg[i];
		lam=(double)num/ (double) NN;
		out[0]=score;
		out[1]=lam;
		return out;
	}
	
}
